1两数之和

  1. 给定一个整数数组 nums 和一个目标值 target,请你在该数组中找出和为目标值的那 两个 整数,并返回他们的数组下标。

    你可以假设每种输入只会对应一个答案。但是,你不能重复利用这个数组中同样的元素。

1
2
3
4
给定 nums = [2, 7, 11, 15], target = 9

因为 nums[0] + nums[1] = 2 + 7 = 9
所以返回 [0, 1]

来源:力扣(LeetCode)
链接:https://leetcode-cn.com/problems/two-sum
著作权归领扣网络所有。商业转载请联系官方授权,非商业转载请注明出处。

方法一:暴力法

暴力法很简单,遍历每个元素 x,并查找是否存在一个值与target−x 相等的目标元素。

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
class Solution {
public int[] twoSum(int[] nums, int target) {
int[] indexs = new int[2];

for(int i=0; i< nums.length; i++) {
for(int j=i+1; j < nums.length; j++) {
if(nums[i] + nums[j] == target) {
indexs[0] = i;
indexs[1] = j;
return indexs;
}
}
}
throw IllegalArgumentException("No two sumsolution");
}
}

对于每个元素,我们试图通过遍历数组的其余部分来寻找它所对应的目标元素,这将耗费 O(n) 的时间。因此时间复杂度为 $O(n^2)$。

方法二:两遍哈希表

为了对运行时间复杂度进行优化,我们需要一种更有效的方法来检查数组中是否存在目标元素。如果存在,我们需要找出它的索引。保持数组中的每个元素与其索引相互对应的最好方法是什么?哈希表

通过以空间换取速度的方式,我们可以将查找时间从 O(n)降低到 O(1)。哈希表正是为此目的而构建的,它支持以 近似 恒定的时间进行快速查找。我用“近似”来描述,是因为一旦出现冲突,查找用时可能会退化到 O(n)。但只要你仔细地挑选哈希函数,在哈希表中进行查找的用时应当被摊销为 O(1)。

一个简单的实现使用了两次迭代。在第一次迭代中,我们将每个元素的值和它的索引添加到表中。然后,在第二次迭代中,我们将检查每个元素所对应的目标元素(target - nums[i])是否存在于表中。注意,该目标元素不能是 nums[i] 本身!

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
class Solution {
public int[] twoSum(int[] nums, int target) {
// 1. 循环nums数组放入map 2. 循环nums找到nums[i]与target-nums[i]
Map<Integer, Integer> map = new Map<>();
for(int i=0; i<nums.length; i++) {
map.put(nums[i], i);
}
for(int i=0; i<nums.length; i++) {
int complement = target - nums[i];
if(map.containsKey(complement) && map.get(complement) != i) {
return new int[] {i, map.get(complement)};
}
}
throw new IllegalArgumentException("NO two sum");
}
}

方法三:一遍哈希表

事实证明,我们可以一次完成。在进行迭代并将元素插入到表中的同时,我们还会回过头来检查表中是否已经存在当前元素所对应的目标元素。如果它存在,那我们已经找到了对应解,并立即将其返回。

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
class Solution {
public int[] twoSum(int[] nums, int target) {
// 1. 循环nums, 判断存在
Map<Integer, Integer> map = new HashMap<>();
for(int i=0; i<nums.length; i++) {
int complement = target - nums[i];
if(map.containsKey(complement) && map.get(complement) != i) {
// return new int[] {i, map.get(complement)};
return new int[] {map.get(complement), i}};
}
map.put(nums[i], i);
}
throw new IllegalArgumentException("No two sum");
}
}
Your browser is out-of-date!

Update your browser to view this website correctly. Update my browser now

×